From e4e07a8d1750e740497910f783f3eef5b3a105ea Mon Sep 17 00:00:00 2001
From: CanbiZ <47820557+MickLesk@users.noreply.github.com>
Date: Wed, 23 Oct 2024 12:01:58 +0200
Subject: [PATCH] Add new LXC: Wallos
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Wallos is a powerful, open-source, and self-hostable web application designed to empower you in managing your finances with ease. Say goodbye to complicated spreadsheets and expensive financial software – Wallos simplifies the process of tracking expenses and helps you gain better control over your financial life.
---
 ct/wallos.sh              | 99 +++++++++++++++++++++++++++++++++++++++
 install/wallos-install.sh | 81 ++++++++++++++++++++++++++++++++
 2 files changed, 180 insertions(+)
 create mode 100644 ct/wallos.sh
 create mode 100644 install/wallos-install.sh

diff --git a/ct/wallos.sh b/ct/wallos.sh
new file mode 100644
index 00000000..0bd4dc27
--- /dev/null
+++ b/ct/wallos.sh
@@ -0,0 +1,99 @@
+#!/usr/bin/env bash
+source <(curl -s https://raw.githubusercontent.com/tteck/Proxmox/main/misc/build.func)
+# Copyright (c) 2021-2024 tteck
+# Author: tteck
+# Co-Author: MickLesk (Canbiz)
+# License: MIT
+# https://github.com/tteck/Proxmox/raw/main/LICENSE
+
+function header_info {
+clear
+cat <<"EOF"
+ _       __      ____          
+| |     / /___ _/ / /___  _____
+| | /| / / __ `/ / / __ \/ ___/
+| |/ |/ / /_/ / / / /_/ (__  ) 
+|__/|__/\__,_/_/_/\____/____/  
+                               
+EOF
+}
+header_info
+echo -e "Loading..."
+APP="Wallos"
+var_disk="5"
+var_cpu="1"
+var_ram="1024"
+var_os="debian"
+var_version="12"
+variables
+color
+catch_errors
+
+function default_settings() {
+  CT_TYPE="1"
+  PW=""
+  CT_ID=$NEXTID
+  HN=$NSAPP
+  DISK_SIZE="$var_disk"
+  CORE_COUNT="$var_cpu"
+  RAM_SIZE="$var_ram"
+  BRG="vmbr0"
+  NET="dhcp"
+  GATE=""
+  APT_CACHER=""
+  APT_CACHER_IP=""
+  DISABLEIP6="no"
+  MTU=""
+  SD=""
+  NS=""
+  MAC=""
+  VLAN=""
+  SSH="no"
+  VERB="no"
+  echo_default
+}
+
+function update_script() {
+header_info
+if [[ ! -d /opt/wallos ]]; then msg_error "No ${APP} Installation Found!"; exit; fi
+if (( $(df /boot | awk 'NR==2{gsub("%","",$5); print $5}') > 80 )); then
+  read -r -p "Warning: Storage is dangerously low, continue anyway? <y/N> " prompt
+  [[ ${prompt,,} =~ ^(y|yes)$ ]] || exit
+fi
+RELEASE=$(curl -s https://api.github.com/repos/ellite/Wallos/releases/latest | grep "tag_name" | awk '{print substr($2, 3, length($2)-4) }')
+if [[ ! -f /opt/${APP}_version.txt ]] || [[ "${RELEASE}" != "$(cat /opt/${APP}_version.txt)" ]]; then
+  msg_info "Updating ${APP} to ${RELEASE}"
+  cd /opt
+  wget -q "https://github.com/ellite/Wallos/archive/refs/tags/v${RELEASE}.zip"
+  mv /opt/wallos/db/wallos.db /opt/wallos.db
+  unzip -q v${RELEASE}.zip
+  mv Wallos-${RELEASE} /opt/wallos
+  rm -rf /opt/wallos/db/wallos.empty.db
+  mv /opt/wallos.db /opt/wallos/db/wallos.db
+  chown -R www-data:www-data /opt/wallos
+  chmod -R 755 /opt/wallos
+  curl http://localhost/endpoints/db/migrate.php &>/dev/null
+  echo "${RELEASE}" >/opt/${APP}_version.txt
+  msg_ok "Updated ${APP}"
+
+  msg_info "Reload Apache2"
+  systemctl reload apache2
+  msg_ok "Apache2 Reloaded"
+
+  msg_info "Cleaning Up"
+  rm -R /opt/v${RELEASE}.zip 
+  msg_ok "Cleaned"
+  msg_ok "Updated Successfully"
+else
+  msg_ok "No update required. ${APP} is already at ${RELEASE}"
+fi
+exit
+}
+
+start
+build_container
+description
+
+msg_ok "Completed Successfully!\n"
+echo -e "${APP} should be reachable by going to the following URL.
+         ${BL}http://${IP} ${CL} \n"
diff --git a/install/wallos-install.sh b/install/wallos-install.sh
new file mode 100644
index 00000000..0407b05f
--- /dev/null
+++ b/install/wallos-install.sh
@@ -0,0 +1,81 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2021-2024 tteck
+# Author: tteck
+# Co-Author: MickLesk (Canbiz)
+# License: MIT
+# https://github.com/tteck/Proxmox/raw/main/LICENSE
+# Source: https://github.com/ellite/wallos
+
+source /dev/stdin <<< "$FUNCTIONS_FILE_PATH"
+color
+verb_ip6
+catch_errors
+setting_up_container
+network_check
+update_os
+
+msg_info "Installing Dependencies"
+$STD apt-get install -y \
+  curl \
+  sudo \
+  mc \
+  apache2 \
+  libapache2-mod-php \
+  php8.2-{mbstring,gd,curl,intl,imagick,bz2,sqlite3,zip,xml} 
+msg_ok "Installed Dependencies"
+
+msg_info "Installing Wallos (Patience)"
+cd /opt
+RELEASE=$(curl -s https://api.github.com/repos/ellite/Wallos/releases/latest | grep "tag_name" | awk '{print substr($2, 3, length($2)-4) }')
+wget -q "https://github.com/ellite/Wallos/archive/refs/tags/v${RELEASE}.zip"
+unzip -q v${RELEASE}.zip
+mv Wallos-${RELEASE} /opt/wallos
+cd /opt/wallos
+mv /opt/wallos/db/wallos.empty.db /opt/wallos/db/wallos.db
+chown -R www-data:www-data /opt/wallos
+chmod -R 755 /opt/wallos
+echo "${RELEASE}" >"/opt/${APPLICATION}_version.txt"
+
+cat <<EOF >/etc/apache2/sites-available/wallos.conf
+<VirtualHost *:80>
+    ServerAdmin webmaster@localhost
+    DocumentRoot /opt/wallos
+
+    <Directory /opt/wallos>
+        Options Indexes FollowSymLinks
+        AllowOverride All
+        Require all granted
+    </Directory>
+
+    ErrorLog \${APACHE_LOG_DIR}/wallos_error.log
+    CustomLog \${APACHE_LOG_DIR}/wallos_access.log combined
+</VirtualHost>
+EOF
+$STD a2ensite wallos.conf
+$STD a2dissite 000-default.conf  
+$STD systemctl reload apache2
+$STD curl http://localhost/endpoints/db/migrate.php
+msg_ok "Installed Wallos"
+
+msg_info "Setting up Crontabs" 
+cat <<EOF > /opt/wallos.cron
+0 1 * * * php /opt/wallos/endpoints/cronjobs/updatenextpayment.php >> /var/log/cron/updatenextpayment.log 2>&1
+0 2 * * * php /opt/wallos/endpoints/cronjobs/updateexchange.php >> /var/log/cron/updateexchange.log 2>&1
+0 8 * * * php /opt/wallos/endpoints/cronjobs/sendcancellationnotifications.php >> /var/log/cron/sendcancellationnotifications.log 2>&1
+0 9 * * * php /opt/wallos/endpoints/cronjobs/sendnotifications.php >> /var/log/cron/sendnotifications.log 2>&1
+*/2 * * * * php /opt/wallos/endpoints/cronjobs/sendverificationemails.php >> /var/log/cron/sendverificationemail.log 2>&1
+*/2 * * * * php /opt/wallos/endpoints/cronjobs/sendresetpasswordemails.php >> /var/log/cron/sendresetpasswordemails.log 2>&1
+0 */6 * * * php /opt/wallos/endpoints/cronjobs/checkforupdates.php >> /var/log/cron/checkforupdates.log 2>&1
+EOF
+crontab /opt/wallos.cron
+msg_ok "Crontabs setup"
+
+motd_ssh
+customize
+
+msg_info "Cleaning up"
+rm -rf /opt/v${RELEASE}.zip
+$STD apt-get -y autoremove
+$STD apt-get -y autoclean
+msg_ok "Cleaned"
\ No newline at end of file